<?php

declare(strict_types=1);

namespace DoctrineMigrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20221014101044 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->addSql('ALTER TABLE model_has_permissions DROP FOREIGN KEY model_has_permissions_permission_id_foreign');
        $this->addSql('ALTER TABLE role_has_permissions DROP FOREIGN KEY role_has_permissions_permission_id_foreign');
        $this->addSql('ALTER TABLE model_has_roles DROP FOREIGN KEY model_has_roles_role_id_foreign');
        $this->addSql('ALTER TABLE role_has_permissions DROP FOREIGN KEY role_has_permissions_role_id_foreign');
        $this->addSql('DROP TABLE failed_jobs');
        $this->addSql('DROP TABLE hackatons');
        $this->addSql('DROP TABLE migrations');
        $this->addSql('DROP TABLE model_has_permissions');
        $this->addSql('DROP TABLE model_has_roles');
        $this->addSql('DROP TABLE password_resets');
        $this->addSql('DROP TABLE permissions');
        $this->addSql('DROP TABLE role_has_permissions');
        $this->addSql('DROP TABLE roles');
        $this->addSql('DROP TABLE users');
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql('CREATE TABLE failed_jobs (id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, uuid VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, connection TEXT CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, queue TEXT CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, payload LONGTEXT CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, exception LONGTEXT CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, failed_at DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL, UNIQUE INDEX failed_jobs_uuid_unique (uuid), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE hackatons (id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, titre VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, description VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, videourl VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, regles VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, prix VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, datedebutinscription DATETIME NOT NULL, datefininscription DATETIME NOT NULL, datedebutcompetition DATETIME NOT NULL, datefincompetition DATETIME NOT NULL, created_at DATETIME DEFAULT NULL, updated_at DATETIME DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE migrations (id INT UNSIGNED AUTO_INCREMENT NOT NULL, migration VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, batch INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE model_has_permissions (permission_id BIGINT UNSIGNED NOT NULL, model_type VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, model_id BIGINT UNSIGNED NOT NULL, INDEX model_has_permissions_model_id_model_type_index (model_id, model_type), INDEX IDX_6B22422AFED90CCA (permission_id), PRIMARY KEY(permission_id, model_id, model_type)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE model_has_roles (role_id BIGINT UNSIGNED NOT NULL, model_type VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, model_id BIGINT UNSIGNED NOT NULL, INDEX model_has_roles_model_id_model_type_index (model_id, model_type), INDEX IDX_747E57EAD60322AC (role_id), PRIMARY KEY(role_id, model_id, model_type)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE password_resets (email VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, token VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, created_at DATETIME DEFAULT NULL, INDEX password_resets_email_index (email)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE permissions (id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, name VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, guard_name VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, created_at DATETIME DEFAULT NULL, updated_at DATETIME DEFAULT NULL, UNIQUE INDEX permissions_name_guard_name_unique (name, guard_name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE role_has_permissions (permission_id BIGINT UNSIGNED NOT NULL, role_id BIGINT UNSIGNED NOT NULL, INDEX role_has_permissions_role_id_foreign (role_id), INDEX IDX_8BDE50C2FED90CCA (permission_id), PRIMARY KEY(permission_id, role_id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE roles (id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, name VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, guard_name VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, created_at DATETIME DEFAULT NULL, updated_at DATETIME DEFAULT NULL, UNIQUE INDEX roles_name_guard_name_unique (name, guard_name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('CREATE TABLE users (id BIGINT UNSIGNED AUTO_INCREMENT NOT NULL, name VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, email VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, email_verified_at DATETIME DEFAULT NULL, password VARCHAR(191) CHARACTER SET utf8 NOT NULL COLLATE `utf8_general_ci`, remember_token VARCHAR(100) CHARACTER SET utf8 DEFAULT NULL COLLATE `utf8_general_ci`, created_at DATETIME DEFAULT NULL, updated_at DATETIME DEFAULT NULL, UNIQUE INDEX users_email_unique (email), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE `utf8_unicode_ci` ENGINE = InnoDB COMMENT = \'\' ');
        $this->addSql('ALTER TABLE model_has_permissions ADD CONSTRAINT model_has_permissions_permission_id_foreign FOREIGN KEY (permission_id) REFERENCES permissions (id) ON UPDATE NO ACTION ON DELETE CASCADE');
        $this->addSql('ALTER TABLE model_has_roles ADD CONSTRAINT model_has_roles_role_id_foreign FOREIGN KEY (role_id) REFERENCES roles (id) ON UPDATE NO ACTION ON DELETE CASCADE');
        $this->addSql('ALTER TABLE role_has_permissions ADD CONSTRAINT role_has_permissions_permission_id_foreign FOREIGN KEY (permission_id) REFERENCES permissions (id) ON UPDATE NO ACTION ON DELETE CASCADE');
        $this->addSql('ALTER TABLE role_has_permissions ADD CONSTRAINT role_has_permissions_role_id_foreign FOREIGN KEY (role_id) REFERENCES roles (id) ON UPDATE NO ACTION ON DELETE CASCADE');
    }
}
